package ITI8590.Partitions is

   type Element   is new Integer;
   type Partition is private;

   function Singletons(Minimum, Maximum : in Element) return Partition;
   procedure Unite(Data : in out Partition; Item_1, Item_2 : in Element);
   function Part(Data : in Partition; Item : in Element) return Element;

private

   type Node is record
      Parent : Element;
      Rank   : Natural;
   end record;

   type Nodes is array (Element range <>) of Node;

   type Partition is access Nodes;

end ITI8590.Partitions;
